' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' C_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/03/09 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft

Public Class frmMain

    '
    Private Const PI As Double = 3.14159265358979

    '͈
    Private m_GSearchExeRegion As New FvRectangle
    Private m_OuterCircle As New FvCircle   'O~

    Private m_intCheckCircleRadius As Integer     '~̔a
    Private m_intCheckCirclePitch As Integer      '~̃sb`
    Private m_intCheckToleranceLevel As Integer   '苖el

    Private m_StandardPoint As New FvPoint  'T[`
    Private m_intStandardDensity() As Integer 'Zxϒl

    'rfIfoCXI[vĂ邩
    Private m_blnVideoOpened As Boolean

    'IꂽrfIݒt@C̃tpX
    Private m_strVideoConfFilePath As String

    'ƃfBNg
    Private m_strDirectory As String

    Private Sub frmMain_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        Dim intErr As Integer
        Dim frmVideoConf As New frmSelectVideoConfFile
        Dim frmLicence As New frmLicence

        'ݒpRg[̏
        cmbSearchMode.Items.Add("ʏ̃p^[")   ' NORMAL_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' BLACK_LINE_PATTERN"
        cmbSearchMode.Items.Add("̃p^[") ' WHITE_LINE_PATTERN"
        cmbSearchMode.Items.Add("sp^[")   ' UNSTABLE_PATTERN"
        cmbSearchMode.SelectedIndex = 0

        cmbPrecision.Items.Add("ʏ퐸x") ' NORMAL_MODE"
        cmbPrecision.Items.Add("x")   ' HIGH_MODE"
        cmbPrecision.Items.Add("x") ' SUPER_MODE"
        cmbPrecision.SelectedIndex = 0

        m_blnVideoOpened = False
        btnGrab.Enabled = False

        'ƃfBNgޔ
        m_strDirectory = Directory.GetCurrentDirectory()

        'gp̊mF
        If frmLicence.ShowDialog() = Yes Then
            'rfIݒt@C̑I
            m_strVideoConfFilePath = ""
            If frmVideoConf.ShowDialog() = OK Then
                m_strVideoConfFilePath = frmVideoConf.strVideoConfFilePath
            End If

            If m_strVideoConfFilePath.Length <> 0 Then
                'rfIݒt@CR|[lgɐݒ
                AxFvxVideo1.VideoConfFile = m_strVideoConfFilePath

                'Lv`{[h̃I[v
                Try
                    AxFvxVideo1.OpenDevice()
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("Lv`{[h̃I[vɎs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'VideoConfFile̕ύXOpenDevicesƃgK[h̕ύX܂B
                '̂߁AЃLv`{[hFVC02ł350ms̃ZbgAbv^CKvɂȂ܂
                '{vOł͊ȗ̂߂Ɉꗥ350ms̃ZbgAbv^CmۂĂ܂A
                'ۂ̃vOł͂g̃Lv`{[hɍ킹ĕύXĂB
                Threading.Thread.Sleep(350)

                'GrabSync/GrabASync\bhłImageTCY̕ύXs܂̂ŁA
                '炩ChangeImageSize\bhɂImagẽTCYύXĂĂB
                'i荞݃TCYImagẽTCYႤꍇ̓G[ɂȂ܂j
                AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

                Try
                    '捞
                    AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
                Catch ex As System.Exception
                    AxFvxVideo1.GetErrReport(intErr)
                    MsgBox("rfI̎捞Ɏs܂ ErrCode = " + intErr.ToString() & vbCrLf & "摜t@Ĉ݂̗pɂȂ܂B", vbExclamation, "G[")
                    Exit Sub
                End Try

                'Lv`{[h̏Ԃۑ
                m_blnVideoOpened = True
                btnGrab.Enabled = True
            End If
        Else
            'uӂ܂vIꂽꍇ̓TvvOI
            End
        End If

        frmDisplayEx.Show()

        'ʂ̐
        frmDisplayEx.AxFvxDisplayEx1.CreateDisplay()
        '摜\
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

        'OCT[`͈͂̏lݒ(摜̑Sʂɐݒj
        m_GSearchExeRegion.xs = -1
        m_GSearchExeRegion.xe = -1
        m_GSearchExeRegion.ys = -1
        m_GSearchExeRegion.ye = -1

        'O~̏ݒ
        m_OuterCircle.x = 200
        m_OuterCircle.y = 200
        m_OuterCircle.radius = 100

    End Sub

    Private Sub frmMain_FormClosed(ByVal sender As System.Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles MyBase.FormClosed

        If m_blnVideoOpened = True Then
            'Lv`{[hI[vĂꍇ̓N[Y
            AxFvxVideo1.CloseDevice()
        End If

    End Sub

    'p^[o^
    Private Sub btnSetPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPattern.Click

        Dim pRect As New FvRectangle    'p^[̈̐ݒ
        Dim pPoint As New FvPoint       'p^[_

        Dim intOK As Integer
        Dim dblTemp As Double

        'o^̏`ݒ
        pRect.xs = 100
        pRect.ys = 100
        pRect.xe = 200
        pRect.ye = 200
        AxFvxROI2.SetRectangle(pRect)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI2.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI2.CheckRectangle = 1 Then
            AxFvxROI2.GetRectangle(pRect)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If pRect.xe < pRect.xs Then
                dblTemp = pRect.xs
                pRect.xs = pRect.xe
                pRect.xe = dblTemp
            End If
            If pRect.ye < pRect.ys Then
                dblTemp = pRect.ys
                pRect.ys = pRect.ye
                pRect.ye = dblTemp
            End If

            If AxFvxROI2.CheckPoint = 1 Then
                AxFvxROI2.GetPoint(pPoint)
            Else
                MsgBox("p^[_w肳܂łB" & vbCr & "p^[`̒S_Ƃēo^܂", , "p^[o^")

                pPoint.x = (pRect.xs + pRect.xe) / 2
                pPoint.y = (pRect.ys + pRect.ye) / 2
            End If

            AxFvxPattern1.MakePattern(AxFvxImage1.GetOcx(), pRect, pPoint)
        End If

    End Sub

    'p^[̃}XNݒ
    Private Sub btnSetPatternMask_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetPatternMask.Click

        AxFvxPattern1.DefMask()

    End Sub

    'p^[\
    Private Sub btnDispPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDispPattern.Click

        AxFvxPattern1.Disp()

    End Sub

    'p^[t@C̓Ǎ
    Private Sub btnLoadPattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadPattern.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        OpenFileDialog1.DefaultExt = "*.pat"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length <> 0 Then
            Try
                AxFvxPattern1.LoadPattrenFileName = OpenFileDialog1.FileName
                AxFvxPattern1.Load()
            Catch ex As Exception
                MsgBox("p^[Ǎݎs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    'p^[t@C̕ۑ
    Private Sub btnSavePattern_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSavePattern.Click

        'p^[t@C̊gq͓Ɍ߂Ă܂񂪁A
        ' "pat"gp邱Ƃ𐄏܂
        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "pattern file(*.pat)|*.pat"
        SaveFileDialog1.DefaultExt = "*.pat"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length <> 0 Then
            Try
                AxFvxPattern1.SavePattrenFileName = SaveFileDialog1.FileName
                AxFvxPattern1.Save()
            Catch ex As Exception
                MsgBox("p^[ۑs", vbExclamation, "G[")
            End Try
        End If

    End Sub

    'J摜荞
    Private Sub btnGrab_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGrab.Click

        '摜t@Cǂݍ݂ɂĉ摜TCY
        'ύXĂ\邽߁AChangeImageSizesĂ܂B
        '摜TCYύX\ꍇ́AɈxsΖ肠܂B
        AxFvxVideo1.ChangeImageSize(AxFvxImage1.GetOcx())

        Try
            '捞
            AxFvxVideo1.GrabSync(AxFvxImage1.GetOcx())
        Catch ex As System.Exception
            Dim intErr As Integer
            AxFvxVideo1.GetErrReport(intErr)
            MsgBox("rfI̎捞Ɏs܂ErrCode=" + intErr.ToString(), vbExclamation, "G[")
        End Try

        '摜\
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())

    End Sub

    '摜t@CǍ
    Private Sub btnLoadImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnLoadImage.Click

        '_CAOɂĉ摜t@CI
        OpenFileDialog1.InitialDirectory = m_strDirectory
        OpenFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        OpenFileDialog1.DefaultExt = "*.bmp"
        OpenFileDialog1.ShowDialog()

        If OpenFileDialog1.FileName.Length > 0 Then

            'FvxFileAccesspăt@CFvxImageɉ摜Ǎ
            AxFvxFileAccess1.FilePath = OpenFileDialog1.FileName

            Try
                AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("Ǎ݂Ɏs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ǂݍݎs")
                Exit Sub
            End Try

            '摜^Cv`FbN
            If AxFvxImage1.BitPerPixel <> 8 Or AxFvxImage1.ImageType <> FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray Then

                MsgBox("8bitOC̉摜ł͂܂", , "error")
                AxFvxImage1.BitPerPixel = 8
                AxFvxImage1.ImageType = FVXCOMIMAGELib.FVXIMAGE_IMAGE_TYPE.imageGray
                AxFvxImage1.ImageWidth = 512
                AxFvxImage1.ImageHeight = 480
            End If

            '摜\
            frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        End If

    End Sub

    '摜t@Cۑ
    Private Sub btnSaveImage_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSaveImage.Click

        SaveFileDialog1.InitialDirectory = m_strDirectory
        SaveFileDialog1.Filter = "bitmap file(*.bmp)|*.bmp"
        SaveFileDialog1.DefaultExt = "*.bmp"
        SaveFileDialog1.ShowDialog()

        If SaveFileDialog1.FileName.Length > 0 Then
            'FvxFileAccesspFvxImaget@Cɕۑ
            AxFvxFileAccess1.FilePath = SaveFileDialog1.FileName()

            Try
                AxFvxFileAccess1.SaveBitmap(AxFvxImage1.GetOcx())
            Catch ex As System.Exception
                Dim intErr As Integer
                AxFvxFileAccess1.GetErrReport(intErr)
                MsgBox("ۑɎs܂B(ErrCode=" & intErr.ToString() & ")", vbExclamation, "ۑs")
                Exit Sub
            End Try
        End If

    End Sub

    'OCT[`͈̏͂̐ݒ
    Private Sub btnGSearchExeRegion_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnGSearchExeRegion.Click

        Dim intOK As Integer
        Dim dblTemp As Double

        AxFvxROI1.SetRectangle(m_GSearchExeRegion)

        'FvxROIgď͈͑I_CAO\
        AxFvxROI1.UsePoint = False
        AxFvxROI1.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI1.CheckRectangle = 1 Then
            AxFvxROI1.GetRectangle(m_GSearchExeRegion)

            'n_ƏI_tɂȂĂȂǂ`FbN܂
            'FvxROIŋ`f[^ꍇAƉE̍WʒutɂȂĂꍇ(xs > xe, ys > ye)ł
            'ւɂ̂܂܌ʂԂ܂̂łӂB
            If m_GSearchExeRegion.xe < m_GSearchExeRegion.xs Then
                dblTemp = m_GSearchExeRegion.xs
                m_GSearchExeRegion.xs = m_GSearchExeRegion.xe
                m_GSearchExeRegion.xe = dblTemp
            End If
            If m_GSearchExeRegion.ye < m_GSearchExeRegion.ys Then
                dblTemp = m_GSearchExeRegion.ys
                m_GSearchExeRegion.ys = m_GSearchExeRegion.ye
                m_GSearchExeRegion.ye = dblTemp
            End If
        End If

    End Sub

    'ROI_CAOɂ錟O~̐ݒ
    Private Sub btnSetCircle_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetCircle.Click

        Dim intOK As Integer

        AxFvxROI3.SetCircle(m_OuterCircle)

        'FvxROIgď͈͑I_CAOo܂
        AxFvxROI3.UseCircle = True
        AxFvxROI3.UseRectangle = False
        AxFvxROI3.UsePoint = False
        AxFvxROI3.MakeROIDialog(AxFvxImage1.GetOcx(), intOK)

        If intOK = 1 And AxFvxROI3.CheckCircle = 1 Then
            AxFvxROI3.GetCircle(m_OuterCircle)

            frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_OuterCircle)
        End If

    End Sub

    '_w聕oXgɂ錟O~̐ݒ
    Private Sub btnSetCircleByPoint_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetCircleByPoint.Click

        frmDisplayEx.Show()
        frmSetCircleRobust.showdialog()

        If frmSetCircleRobust.CheckCircle = True Then
            frmSetCircleRobust.GetCircle(m_OuterCircle)

            frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_OuterCircle)
        End If

    End Sub

    'ep[^̓Kp
    Private Function ApplyChanges() As Integer

        Dim intTemp As Integer

        ApplyChanges = -1

        'p[^ݒ
        AxFvxCorrelation1.SetInspectArea(m_GSearchExeRegion)                   '͈
        AxFvxCorrelation1.SearchMode = cmbSearchMode.SelectedIndex    'T[`[hiׂȂǂ̃p^[Ɏgpj
        AxFvxCorrelation1.Precision = cmbPrecision.SelectedIndex      'T[`

        '摜̏
        If Integer.TryParse(txtCondition.Text, intTemp) = False Or intTemp < 1 Or intTemp > 9 Then
            MsgBox("Ԃ 1`9 ̊ԂŐݒ肵Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxCorrelation1.Condition = intTemp

        '臒l
        If Integer.TryParse(txtThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("XRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxCorrelation1.ScoreThresh = intTemp

        'r臒l
        If Integer.TryParse(txtMiddleThreshold.Text, intTemp) = False Or intTemp < 10 Or intTemp > 99 Then
            MsgBox("rXRA 10`99 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Function
        End If
        AxFvxCorrelation1.ScoreThresh2 = intTemp

        'T[`
        AxFvxCorrelation1.SearchNum = 1

        '͈͐ڐGĂ̂o邩ǂ
        If chkWndTouch.Checked = True Then
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.ON
        Else
            AxFvxCorrelation1.WindowTouch = FVXCOMCORRELATIONLib.WINDOW_TOUCH_TYPE.OFF
        End If


        'ϔZx

        '~a
        If Integer.TryParse(txtCheckCircleRadius.Text, intTemp) = False Or intTemp < 0 Or intTemp > 50 Then
            MsgBox("~a 0`50 ̊Ԃœ͂Ă", , "p[^G[")
            Exit Function
        End If
        m_intCheckCircleRadius = intTemp

        '~sb`
        If Integer.TryParse(txtCheckCircleAnglePitch.Text, intTemp) = False Or intTemp < 0 Or intTemp > 180 Then
            MsgBox("~sb` 0`180 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Function
        End If
        m_intCheckCirclePitch = intTemp
        ReDim Preserve m_intStandardDensity(360 / intTemp)


        'ǔ۔苖e(})
        If Integer.TryParse(txtCheckToleranceLevel.Text, intTemp) = False Or intTemp < 0 Or intTemp > 255 Then
            MsgBox("ǔ۔苖e 0`255 ̊Ԃœ͂Ă", vbExclamation, "G[")
            Exit Function
        End If
        m_intCheckToleranceLevel = intTemp

        ApplyChanges = 0

    End Function

    'OCT[`s(擾錋ʂ1)
    'p[^͐ݒ肵Ȃ̂ŁA炩ߔfĂĉB
    Private Function DoSearch(ByVal pResult As FvSearchResult) As Integer

        Dim intSearchedNum As Integer
        Dim intErr As Integer

        Try
            'p^[ݒ
            AxFvxCorrelation1.SetPattern(AxFvxPattern1.GetOcx())

            'T[`s
            AxFvxCorrelation1.Execute(AxFvxImage1.GetOcx(), intSearchedNum)

            If intSearchedNum > 0 Then
                AxFvxCorrelation1.GetResult(0, pResult)
            End If

            DoSearch = 0
        Catch ex As Exception
            AxFvxCorrelation1.GetErrReport(intErr)
            MsgBox(GetCorrelationErrMesg(intErr), vbExclamation, "OCT[`G[")

            DoSearch = -1
        End Try

    End Function

    '_A(lng_x,lng_y)𒆐SƂ锼am_CheckCircleRadius̉~̓̕ϔZxl߂
    Private Function CalcAverage(ByVal int_x As Integer, ByVal int_y As Integer) As Integer

        Dim pPoint As New FvPoint
        Dim intDensity As Integer
        Dim intSum As Integer
        Dim intCount As Integer
        Dim xs As Integer
        Dim xe As Integer
        Dim ys As Integer
        Dim ye As Integer

        Dim i As Integer
        Dim j As Integer

        xs = int_x - m_intCheckCircleRadius
        ys = int_y - m_intCheckCircleRadius
        xe = int_x + m_intCheckCircleRadius
        ye = int_y + m_intCheckCircleRadius

        'NbsO
        If xs < 0 Then xs = 0
        If ys < 0 Then ys = 0
        If xe < 0 Then xe = 0
        If ye < 0 Then ye = 0
        If xs >= AxFvxImage1.ImageWidth Then xs = AxFvxImage1.ImageWidth - 1
        If xe >= AxFvxImage1.ImageWidth Then xe = AxFvxImage1.ImageWidth - 1
        If ys >= AxFvxImage1.ImageHeight Then ys = AxFvxImage1.ImageHeight - 1
        If ye >= AxFvxImage1.ImageHeight Then ye = AxFvxImage1.ImageHeight - 1

        For j = ys To ye
            For i = xs To xe

                '~̓H
                '(O̒藝ŉ~S̋߁AaƔrj
                If ((i - int_x) * (i - int_x) + (j - int_y) * (j - int_y)) <= m_intCheckCircleRadius * m_intCheckCircleRadius Then
                    pPoint.x = i
                    pPoint.y = j
                    AxFvxImage1.GetPixel(pPoint, intDensity)
                    intSum = intSum + intDensity
                    intCount = intCount + 1
                End If
            Next
        Next

        'OZɂȂȂ悤Ƀ`FbN
        If intCount > 0 Then
            CalcAverage = intSum / intCount
        Else
            CalcAverage = 0
        End If

    End Function

    'v
    Private Sub btnSetStandard_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnSetStandard.Click

        Dim pSearchResult As New FvSearchResult     'OCT[`̌

        Dim pCheckCircle As New FvCircle    '~
        Dim pPoint As New FvPoint           'Zxl擾p

        Dim x As Integer   '~S
        Dim y As Integer

        Dim intCount As Integer
        Dim i As Integer

        'p[^Kp
        If ApplyChanges() = -1 Then Exit Sub

        'ʏ
        txtResult.Text = ""
        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()

        '`Fݒ
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        frmDisplayEx.AxFvxDisplayEx1.FontColor = System.Drawing.Color.FromArgb(255, 0, 0)

        intCount = 0
        For i = 0 To 360 Step m_intCheckCirclePitch

            'O~̓_vZ
            x = m_OuterCircle.x + (m_OuterCircle.radius * Math.Cos(i * PI / 180))
            y = m_OuterCircle.y + (m_OuterCircle.radius * Math.Sin(i * PI / 180))

            'ϔZxlZo
            m_intStandardDensity(intCount) = CalcAverage(x, y)

            '~\
            pCheckCircle.x = x
            pCheckCircle.y = y
            pCheckCircle.radius = m_intCheckCircleRadius
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pCheckCircle)

            'Zxl\
            pPoint.x = x
            pPoint.y = y
            frmDisplayEx.AxFvxDisplayEx1.DrawText(0, pPoint, Str(m_intStandardDensity(intCount)))

            intCount = intCount + 1
        Next

        'OCT[`͈͂ŕ\
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_GSearchExeRegion)

        'OCT[`̎s
        If DoSearch(pSearchResult) = 0 Then
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pSearchResult)

            '̃T[`ʂACgƂĕۑ
            m_StandardPoint.x = pSearchResult.x
            m_StandardPoint.y = pSearchResult.y

        End If

    End Sub

    's
    Private Sub btnExecute_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExecute.Click

        Dim pSearchResult As New FvSearchResult 'OCT[`

        Dim pPoint As New FvPoint           'Zxl擾p
        Dim pCheckCircle As New FvCircle    '~

        Dim intNowAveDensity As Integer    'ڌ~̕ϔZxl

        Dim x As Integer           '~S
        Dim y As Integer
        Dim intCenterX As Integer  'ACgꂽO~S
        Dim intCenterY As Integer
        Dim intDiffX As Integer    'XWY
        Dim intDiffY As Integer    'YWY

        Dim dblTime As Double   '
        Dim intNGCount As Integer  'ǔ۔NGɂȂ
        Dim intCount As Integer '~ԍ
        Dim i As Integer

        intCount = 0
        intNGCount = 0

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()

        'p[^Kp
        If ApplyChanges() = -1 Then Exit Sub

        'ԌvJn
        AxFvxPerformanceCounter1.StartCount()

        'OCT[`͈͂ŕ\
        frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, m_GSearchExeRegion)

        If DoSearch(pSearchResult) = 0 Then

            'T[`ʂԂŕ\
            frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)
            frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pSearchResult)

            'ʒũYʌvZ
            intDiffX = pSearchResult.x - m_StandardPoint.x
            intDiffY = pSearchResult.y - m_StandardPoint.y

            txtResult.Text = "T[`W : ( " & VisualBasic.Format(pSearchResult.x, "0.0") & _
                             " , " & VisualBasic.Format(pSearchResult.y, "0.0") & " )" & vbCrLf & _
                             "Yw : " & VisualBasic.Format(intDiffX) & vbCrLf & _
                             "Yx : " & VisualBasic.Format(intDiffY) & vbCrLf

            'O~SACg
            intCenterX = m_OuterCircle.x + intDiffX
            intCenterY = m_OuterCircle.y + intDiffY

            '~͑߂ɕ\
            frmDisplayEx.AxFvxDisplayEx1.PenWidth = 2

            intCount = 0
            For i = 0 To 360 Step m_intCheckCirclePitch

                'O~̓_vZ
                x = intCenterX + (m_OuterCircle.radius * Math.Cos(i * PI / 180))
                y = intCenterY + (m_OuterCircle.radius * Math.Sin(i * PI / 180))

                'ϔZxlZo
                intNowAveDensity = CalcAverage(x, y)

                'Zxl\
                pPoint.x = x
                pPoint.y = y
                frmDisplayEx.AxFvxDisplayEx1.DrawText(0, pPoint, Str(intNowAveDensity))

                'ǔ۔
                If (m_intStandardDensity(intCount) - m_intCheckToleranceLevel) > intNowAveDensity _
                    Or (m_intStandardDensity(intCount) + m_intCheckToleranceLevel) < intNowAveDensity Then
                    'ہ@FԂŌ~\  ~}[N\
                    frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(255, 0, 0)
                    DrawCrossMark(x, y)
                    intNGCount = intNGCount + 1
                Else
                    'ǁ@FŌ~\
                    frmDisplayEx.AxFvxDisplayEx1.PenColor = System.Drawing.Color.FromArgb(0, 0, 255)
                End If

                '~\
                pCheckCircle.x = x
                pCheckCircle.y = y
                pCheckCircle.radius = m_intCheckCircleRadius
                frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pCheckCircle)

                intCount = intCount + 1
            Next

            'ɖ߂
            frmDisplayEx.AxFvxDisplayEx1.PenWidth = 1

        End If

        'ԌvI
        AxFvxPerformanceCounter1.StopCount(dblTime)

        txtResult.Text = " : " & VisualBasic.Format(dblTime, "0.00ms") & vbCrLf & _
                            "mf : " & VisualBasic.Format(intNGCount) & vbCrLf & vbCrLf _
                            & txtResult.Text

    End Sub

    '~}[N\
    Private Sub DrawCrossMark(ByVal int_x As Integer, ByVal int_y As Integer)

        Dim pLineSeg As New FvLineSegment

        pLineSeg.xs = int_x - 5
        pLineSeg.ys = int_y - 5
        pLineSeg.xe = int_x + 5
        pLineSeg.ye = int_y + 5
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pLineSeg)

        pLineSeg.xs = int_x - 5
        pLineSeg.ys = int_y + 5
        pLineSeg.xe = int_x + 5
        pLineSeg.ye = int_y - 5
        frmDisplayEx.AxFvxDisplayEx1.DrawData(0, pLineSeg)

    End Sub

    Private Sub btnDoSample_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDoSample.Click

        Dim intErr As Integer

        '}X^摜ǂݍ
        AxFvxFileAccess1.FilePath = My.Application.Info.DirectoryPath & "\sample1.bmp"
        AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
        AxFvxFileAccess1.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample1.bmpǂݍ߂܂ł")
            Exit Sub
        End If

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        MsgBox("}X^摜ǂݍ")


        'p^ǂݍ
        AxFvxPattern1.LoadPattrenFileName = My.Application.Info.DirectoryPath & "\sample.pat"
        AxFvxPattern1.Load()
        AxFvxPattern1.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample.patǂݍ߂܂ł")
            Exit Sub
        End If

        'O~ݒ
        m_OuterCircle.x = 192
        m_OuterCircle.y = 300
        m_OuterCircle.radius = 93

        'ʒu
        btnSetStandard_Click(sender, e)
        MsgBox("p^Ǎ݁")

        '摜ǂݍ
        AxFvxFileAccess1.FilePath = My.Application.Info.DirectoryPath & "\sample2.bmp"
        AxFvxFileAccess1.LoadBitmap(AxFvxImage1.GetOcx())
        AxFvxFileAccess1.GetErrReport(intErr)
        If intErr <> 0 Then
            MsgBox("sample2.bmpǂݍ߂܂ł")
            Exit Sub
        End If

        frmDisplayEx.AxFvxDisplayEx1.ClearOverlay()
        frmDisplayEx.AxFvxDisplayEx1.DrawImage(AxFvxImage1.GetOcx())
        MsgBox("摜ǂݍ")

        's
        btnExecute_Click(sender, e)
        MsgBox("ACgs")

    End Sub

    Public Function GetCorrelationErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetCorrelationErrMesg = "G["
            Case 5001
                GetCorrelationErrMesg = "p^݂Ă܂B"
            Case 5005
                GetCorrelationErrMesg = "p[^Ⴂ܂B"
            Case 5006
                GetCorrelationErrMesg = "^Ⴂ܂B"
            Case 5007
                GetCorrelationErrMesg = "p^摜̂߁Ao^ł܂B"
            Case 5008
                GetCorrelationErrMesg = "p^ƃ}XÑTCYvĂ܂B"
            Case 5009
                GetCorrelationErrMesg = "p[^NULLlw肳܂B"
            Case 5010
                GetCorrelationErrMesg = "̊mۂɎs܂B"
            Case 5022
                GetCorrelationErrMesg = "p^w肳Ă܂B"
            Case Else
                GetCorrelationErrMesg = "sȃG["
        End Select

    End Function


    Public Function GetPatternErrMesg(ByVal intErr As Integer) As String

        Select Case (intErr)
            Case 0
                GetPatternErrMesg = "G["
            Case 9502
                GetPatternErrMesg = "T|[gĂȂC[W^CvłB"
            Case 9505
                GetPatternErrMesg = "p[^Ⴂ܂B"
            Case 9506
                GetPatternErrMesg = "̌^Ⴂ܂B"
            Case 9510
                GetPatternErrMesg = "̊mۂɎs܂B"
            Case 9531
                GetPatternErrMesg = "pX̎w肪ԈĂ܂B"
            Case 9533
                GetPatternErrMesg = "p^[݂܂B"
            Case 9540
                GetPatternErrMesg = "p^݂܂B"
            Case Else
                GetPatternErrMesg = "sȃG["
        End Select

    End Function

    Private Sub txtCondition_KeyPress(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyPressEventArgs) Handles txtThreshold.KeyPress, txtMiddleThreshold.KeyPress, txtCondition.KeyPress, txtCheckToleranceLevel.KeyPress, txtCheckCircleRadius.KeyPress, txtCheckCircleAnglePitch.KeyPress

        'l'-'̂ݓ͂ł悤ɐ
        If ("0"c <= e.KeyChar And e.KeyChar <= "9"c) Or (e.KeyChar = Chr(&H8)) Or (e.KeyChar = Chr(&H2D)) Then
            e.Handled = False
        Else
            e.Handled = True
        End If

    End Sub
End Class
